/****************************************************************************
*
*	  Header Filename:  Library_Headers.h
*	  Module Name:      Utilities Package for SimSoup
*	  Description:      Include file for Library Headers
*                       Also includes VCL Compatibility Support and
*                       special purpose List class. This special list is used because the
*                       STL List template used in the early stages of development (before
*                       STLPort was adopted) had a high memory overhead for a nearly empty List.
*                       Interfaces to the SimSoup System_Monitor and Simulation_Statistics modules are 
*                       also included
*                       Platform.h is a special purpose header to control conditional compilation
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2003, 2004, 2005, 2006, 2008 Chris Gordon-Smith
*     Email: See  http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License Version 2, as published 
*     by the Free Software Foundation.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*	  Amendment History:-
*
*		Version	   Date	   			Update Description
*		=======    ===========		==================
*
*
*
*
****************************************************************************/

//  Standard Headers

#include  <vector>          //STL
#include  <string>          //STL
#include  <queue>           //STL
#include  <exception>       //STL
#include  <sstream>         //STL
#include  <list>            //STL
#include  <set>             //STL
#include  <map>             //STL
#include  <iostream>        //STL
#include  <iomanip>         //STL
#include  <fstream>         //STL
#include  <algorithm>       //STL
#include  <cfloat>
#include  <cmath>
#include  <cstdlib>
#include  <climits>
using namespace std;    


//-------------- log4cpp system ----------------------------------------------------------------------------------
//#include    "log4cpp/Category.hh"
//#include    "log4cpp/FileAppender.hh"
//#include    "log4cpp/BasicLayout.hh"
//#include    "log4cpp/SimpleLayout.hh"
//----------------------------------------------------------------------------------------------------------------

//--------------  Logger  Subsystem  -----------------------------------------------------------------------------
#include  "Logger.h"
#include  "Trace.h"
//----------------------------------------------------------------------------------------------------------------


//  Interfaces to globally available functions in the Utilities Package

#include "VCL_Compatibility_Support.h"
#include "Utility_Functions.h"
#include "System_Monitor.h"
#include "Exception_Types.h"


