/****************************************************************************
*
*	  Header Filename:  Scenario_Series.h
*	  Module Name:      Scenario Series
*	  Description:      Represents and Manages a series of simulation scenarios
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2006 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License as published by the
*     Free Software Foundation; either version 2 of the License, or (at your
*     option) any later version.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*      Amendment History:- 
*
*              Version	  Date                        Update Description
*              =======    ===========                 ==================
*
*
*
*
****************************************************************************/

#ifndef  Scenario_Series_H
#define  Scenario_Series_H

class   Scenario;
//class   Input_Record;
//class   ActReq_Requestor;

class   Scenario_Series {

//===== Relationships with other classes ===================================================================

//=====================================================================================================

    public:
        Scenario*  Get_Curr_Scenario_Ptr();
        bool Iter_To_Next_Scenario();
        Scenario_Series();
        bool Run_Current_Scenario(int Num_Timesteps);
        bool Setup_From_Input_File(string Input_File, string&  Error_Text);
      
    private:
//        bool  Validate_Record_Semantics_And_Make_Requestor(Input_Record*  Rec_Ptr, 
//                                                           ActReq_Requestor*&  Rqstr, 
//                                                           string& Error_Text);        
        list< Scenario*> Scenario_List;
        list< Scenario*>::iterator Current_Scenario_Iter;

};
#endif  //Scenario_Series_H
