/****************************************************************************
*
*     Module Filename:  Simulation_Input.h
*     Module Name:      Simulation_Input
*     Description:      Simulation Input Manager
*
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2007, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License as published by the
*     Free Software Foundation; either version 2 of the License, or (at your
*     option) any later version.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*      Amendment History:- 
*
*              Version	  Date                        Update Description
*              =======    ===========                 ==================
*
*
*
*
****************************************************************************/

#ifndef Simulation_InputH
#define Simulation_InputH

class Input_Record;
   
class   Simulation_Input

{
//===== Relationships with other classes ===================================================================

//==========================================================================================================

	public:
  		Simulation_Input();
        static Simulation_Input*  Get_Ptr() { return  Instance_Ptr;}; 
        bool Read_Input_Records_And_Validate_Syntax(string& PathName, 
                                                    list<Input_Record*>* Input_Records, 
                                                    string& Error_Text); 

        enum Record_Type_Code
            {
                Add_Constr_Req_Rcd_Cd,
                Add_Fission_Req_Rcd_Cd,
                Add_Transfm_Req_Rcd_Cd,
                Add_IntType_Req_Rcd_Cd,
                Add_Mol_Req_Rcd_Cd,
                Add_MolType_Req_Rcd_Cd,
                ChemEvol_Req_Rcd_Cd,
                Comment_Line_Cd
            };
        bool Text_To_Record_Type(string  Line_Type_Text, 
                                 Record_Type_Code&  Ln_Type, 
                                 string& Error_Text);

    private:
        map <string, Record_Type_Code> Record_Type_Map;  // Record Types
        static  Simulation_Input*  Instance_Ptr;
};
    typedef  Simulation_Input  SimInp;
#endif  //Simulation_Input_H
