/****************************************************************************
*
*	  Module Filename:  Form_View_Chemistry.cpp
*	  Module Name:      Form_View_Chemistry
*	  Description:      View Chemistry
*	  Author:   		Chris Gordon-Smith
*
*     Copyright (C) 2003, 2004, 2005, 2006, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License Version 2, as published 
*     by the Free Software Foundation.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*	  Amendment History:-
*
*		Version	   Date	   			Update Description//    TListView__Nodes_Ptr->Get_Items()->Clear();
*		=======    ===========		==================
*
*
*
*
****************************************************************************/
//  Comment out to disallow tracing this file
//#define  ENABLE_TRACE_FILE 

//	Globally used defines

#include    "globldef.h"
#include    "Library_Headers.h"

//----------------  User_Interface_Presentation API --------------------------------------------------------------
#include  "GUI_Presentation_API.h"
//----------------------------------------------------------------------------------------------------------------

//--------------  User Interface Manager  -----------------------------------------------------------------------
#include    "Network_Painter_Prot.h"
#include    "Form_View_Chemistry.h"
#include    "Form_Main.h"
//---------------------------------------------------------------------------------------------------------------

//--------------  Kernel_Manager Subsystem  ----------------------------------------------------------------------
#include  "Krnl_Vis.h"
//----------------------------------------------------------------------------------------------------------------

//  Static Data

TForm__View_Chemistry* TForm__View_Chemistry::Form_Ptr = 0;
//------------------------------------------------------------------------------
void    TForm__View_Chemistry::Add_Item_Of_Node_Type() const

//  Add a Molecule of the selected type to the Reactor

{

//    COMMENTED OUT BECAUSE IT LOOKS WRONG. FOUND AS PART OF CODE SCAN TO
//    PRODUCE UML DIAGRAMS
//    Reactor::Get_Reactor__Ptr()->Add_Molecule_Of_Type(Get_Selected_Mol_Type());
}
//----------------------------------------------------------------------------------------------------------
void  TForm__View_Chemistry::Add_Node() const



{
//     **** CODE TO BE COMPLETED
}
//----------------------------------------------------------------------------------------------------------
void  TForm__View_Chemistry::Close_View()

//      Class specific actions required when the Chemistry View is closed

{
    Form_Ptr = 0;
    


//  Update menu options

//    MainForm::Get_Ptr()->Window_Chemistry->Enabled = false;
//    MainForm::Get_Ptr()->Chemistry_View->Enabled = true;
//    MainForm::Get_Ptr()->AddInteractionType1->Enabled = false;
}
    
//----------------------------------------------------------------------------------------------------------
int     TForm__View_Chemistry::Compare_Connections(void*  Node1_Ptr, void* Node2_Ptr) const

//  Compare function to determine sort order of Interaction_Types

{
    Interaction_Type* Int_Typ1__Ptr = static_cast<Interaction_Type*> (Node1_Ptr);
    Interaction_Type* Int_Typ2__Ptr = static_cast<Interaction_Type*> (Node2_Ptr);

//    int Int1_Reactant1 = Int_Typ1__Ptr->Get_Reactant1_MolType_Ptr()->Get_Identifier();
    int Int1_Reactant1 = Krnl_Vis::IntType::Get_Reactant1_MolType_Id(Int_Typ1__Ptr);
//    int Int2_Reactant1 = Int_Typ2__Ptr->Get_Reactant1_MolType_Ptr()->Get_Identifier();
    int Int2_Reactant1 = Krnl_Vis::IntType::Get_Reactant2_MolType_Id(Int_Typ1__Ptr);

    if(Int1_Reactant1 < Int2_Reactant1)
    THEN
        return(-1);
    ELSEIF (Int1_Reactant1 > Int2_Reactant1)
    THEN
        return(1);
    ELSE
        Molecule_Type*  Mol_Type_Reactant2 = Krnl_Vis::IntType::Get_Reactant2_MolType_Ptr(Int_Typ1__Ptr);
        if (Mol_Type_Reactant2 == 0)
        THEN
            return(0);     //  Return if there is no Reactant 2 for Int Type 1
        ENDIF

        int Int1_Reactant2 = Krnl_Vis::MolType::Get_Identifier(Mol_Type_Reactant2);

        Mol_Type_Reactant2 = Krnl_Vis::IntType::Get_Reactant2_MolType_Ptr(Int_Typ2__Ptr);
        if (Mol_Type_Reactant2 == 0)
        THEN
            return(0);    //  Return if there is no Reactant 2 for Int Type 2

        ENDIF
//        int Int2_Reactant2 = Int_Typ2__Ptr->Get_Reactant2_MolType_Ptr()->Get_Identifier();
        int Int2_Reactant2 = Krnl_Vis::MolType::Get_Identifier(Mol_Type_Reactant2);

        if (Int1_Reactant2 < Int2_Reactant2)
        THEN
            return(-1);
        ELSEIF (Int1_Reactant2 > Int2_Reactant2)
        THEN
            return(1);
        ELSE
            return(0);
        ENDIF
    ENDIF

}

//----------------------------------------------------------------------------------------------------------
int     TForm__View_Chemistry::Compare_Nodes(void*  Connect1_Ptr, void* Connect2_Ptr) const

//  Compare function to determine sort order of Molecule_Types

{
    Molecule_Type* MolTyp1__Ptr = static_cast<Molecule_Type*> (Connect1_Ptr);
    Molecule_Type* MolTyp2__Ptr = static_cast<Molecule_Type*> (Connect2_Ptr);

//    int MolType1_Id = MolTyp1__Ptr->Get_Identifier();
    int MolType1_Id = Krnl_Vis::MolType::Get_Identifier(MolTyp1__Ptr);
  
//    int MolType2_Id = MolTyp2__Ptr->Get_Identifier();
    int MolType2_Id = Krnl_Vis::MolType::Get_Identifier(MolTyp2__Ptr);

    if (MolType1_Id < MolType2_Id)
    THEN
        return(-1);
    ELSEIF (MolType1_Id > MolType2_Id)
    THEN
        return(1);
    ELSE
        return(0);
    ENDIF
}
//----------------------------------------------------------------------------------------------------------
void  TForm__View_Chemistry::Draw_All_Connections() const
{
    for(bool Continue_Flag = Krnl_Vis::Chemistry_::Iter_To_First_Int_Type();
        Continue_Flag == true;
        Continue_Flag = Krnl_Vis::Chemistry_::Iter_To_Next_Int_Type())
    BEGIN
        Draw_Connection(Krnl_Vis::Chemistry_::Get_Current_Int_Type_Ptr(), EOpt_Connection_Not_Selected);
    END
}
//-----------------------------------------------------------------------------------------------------------
void TForm__View_Chemistry::Draw_All_Nodes() const

//  Display all Molecule_Types in the Chemistry

{
    for (int Continue_Flag = Krnl_Vis::Chemistry_::Iter_To_First_Mol_Type();
         Continue_Flag == true;
         Continue_Flag = Krnl_Vis::Chemistry_::Iter_To_Next_Mol_Type())
    BEGIN
        Draw_Node(Krnl_Vis::Chemistry_::Get_Current_Mol_Type_Ptr());
    END
}
//----------------------------------------------------------------------------------------------------------

void TForm__View_Chemistry::Draw_Connection(void* Void__Interaction_Ptr,
                            int Conn_Selection_State) const

//  Draw the specified connection on the Chemistry View

{
    Interaction_Type*  IntType__Ptr = static_cast<Interaction_Type*> (Void__Interaction_Ptr);

    int Interaction_Type_Identifier;
    Interaction_Type_Enum  Interaction_Type_Enumr;
    int Reactant1_Identifier;
    int Reactant2_Identifier;
    int Product1_Identifier;
    int Product2_Identifier;
    int Catalyst_Identifier;

    Krnl_Vis::IntType::Get_Int_Type_Characteristics(IntType__Ptr,
                                                    Interaction_Type_Identifier,
                                                    Interaction_Type_Enumr,
                                                    Reactant1_Identifier,
                                                    Reactant2_Identifier,
                                                    Product1_Identifier,
                                                    Product2_Identifier,
                                                    Catalyst_Identifier);

    if (Interaction_Type_Enumr == Interaction_Type_Enumr__Fission)
    THEN
        Network_Painter_Prot__Ptr->Draw_Fission(Reactant1_Identifier,
                                                Product1_Identifier,
                                                Product2_Identifier,
                                                1,      // Draw all lines withthe same width
                                                Conn_Selection_State,
                                                true);
    ELSEIF (Interaction_Type_Enumr == Interaction_Type_Enumr__Constr)
    THEN
        Network_Painter_Prot__Ptr->Draw_Construction(Reactant1_Identifier,
                                                    Reactant2_Identifier,
                                                    Product1_Identifier,
                                                    1,      // Draw all lines withthe same width
                                                    Conn_Selection_State,
                                                    true); // Draw for first time, so create a Network Display Item
                                                            // in case need to redraw;



//    Molecule_Type*  Molecule_Type__Ptr;

//    Molecule_Type__Ptr = static_cast<Molecule_Type*> (Void__Molecule_Type_Ptr);

//  Draw the Molecule_Type

//    Molecule_Type__Ptr->Draw(Network_Painter_Prot__Ptr,20);  // Draw a single molecule type
    ELSEIF (Interaction_Type_Enumr == Interaction_Type_Enumr__Transfm)
    THEN
        Network_Painter_Prot__Ptr->Draw_Transformation(Reactant1_Identifier,
                                                       Product1_Identifier,
                                                       1,      // Draw all lines withthe same width
                                                       Conn_Selection_State,
                                                       true);

    ELSE
        Assert (true == false, "TForm__View_Chemistry::Draw_Connection - Invalide Interaction Type");
    ENDIF
} 
//----------------------------------------------------------------------------------------------------------
void TForm__View_Chemistry::Draw_Node(void* Void__Molecule_Type_Ptr) const

//  Cast the Void__Molecule_Type_Ptr to a Molecule_Type pointer and
//  invoke the specified Molecule_Type's Draw_Molecule_Type
//  method

{
    Molecule_Type*  Molecule_Type__Ptr
        = static_cast<Molecule_Type*> (Void__Molecule_Type_Ptr);
//    int MolType_Identifier = Molecule_Type__Ptr->Get_Identifier();
    int MolType_Identifier = Krnl_Vis::MolType::Get_Identifier(Molecule_Type__Ptr);

    Network_Painter_Prot__Ptr->Draw_Molecule_Type(MolType_Identifier,
                                         20, // Display_Size,
                                         EOpt_Node_Not_Selected,
                                         true); // Draw for first time, so create a Network Display Item
                                                // in case need to redraw;
}
//----------------------------------------------------------------------------------------------------------
void   TForm__View_Chemistry::Draw_Text_Output() const

//  Text Output to the Chemistry View

{

//   No text output on the Chemistry View

}

//----------------------------------------------------------------------------------------------------------
void    TForm__View_Chemistry::Draw_Selected_Nodes()  

//  Draw the Nodes that are currently selected.
//  Use colour to show the Selection State.

{
    for(bool Continue_Flag = Selected_Nodes.Iter_To_First();
        Continue_Flag == true;
        Continue_Flag = Selected_Nodes.Iter_To_Next())
    {


//      Draw the selected Nodes

        Network_Painter_Prot__Ptr->
            Draw_Molecule_Type(Selected_Nodes.Get_Current_Node(),
                               150,      // Display One Molecule
                               Selected_Nodes.Get_Node_Selection_State(Selected_Nodes.Get_Current_Node()),
                               true); // Store for redisplay
    }
}
//----------------------------------------------------------------------------------------------------------
void  TForm__View_Chemistry::Get_Conns_Matching_Node_And_Type


                                (list<void*>& List_Of_Connections,
                                 int  Node_Index,
                                 Enum_Node_Selection_State  Selection_State)

//  Populate List_Of_Connections with with Connections that touch the specified Node
//  and match its Selection State.  Eg, if the Node is selected as a Catalyst, then
//  a Connection is included in the list if it has a Catalyst end point touching the Node

{

//  If Node Index is out of range then there can't be any connections for it so return
    
    if (Krnl_Vis::Chemistry_::Get_Number_Of_Molecule_Types() <= Node_Index)
    THEN
        return;
    ENDIF

    Molecule_Type*  Mol_Type__Ptr = Krnl_Vis::Chemistry_::Get_Molecule_Type_Ptr(Node_Index);


//  If the Node is selected as a Reactant or Catalyst, Then look in its
//  list of connections for which the Node (Molecule_Type) is an input.

    if ((Selection_State == EOpt_Node_Selected_As_Reactant)
                                  ||
        (Selection_State == EOpt_Node_Selected_As_Catalyst))

    THEN
//        for (bool Continue_Flag = Mol_Type__Ptr->List_Of_Int_Types_With_MolType_As_Input.Iter_To_First();
        for (bool Continue_Flag = Krnl_Vis::MolType::Iter_To_First_IntType_With_MolType_As_Input(Mol_Type__Ptr);
             Continue_Flag == true;
//           Continue_Flag = Mol_Type__Ptr->List_Of_Int_Types_With_MolType_As_Input.Iter_To_Next())
             Continue_Flag = Krnl_Vis::MolType::Iter_To_Next_IntType_With_MolType_As_Input(Mol_Type__Ptr))
        BEGIN
//            Interaction_Type* Int_Type_Ptr = Mol_Type__Ptr->
//                                            List_Of_Int_Types_With_MolType_As_Input.Get_Current_Item();
            Interaction_Type* Int_Type_Ptr =
                Krnl_Vis::MolType::Get_Current_IntType_With_MolType_As_Input(Mol_Type__Ptr);


//          If Node is selected as a Reactant, then check for a matching Reactant on the Interaction_Type

            if (Selection_State == EOpt_Node_Selected_As_Reactant)
            THEN
                if ((Krnl_Vis::IntType::Get_Reactant1_MolType_Ptr(Int_Type_Ptr) == Mol_Type__Ptr)
                            ||
                    (Krnl_Vis::IntType::Get_Reactant2_MolType_Ptr(Int_Type_Ptr) == Mol_Type__Ptr))
                THEN
                    List_Of_Connections.push_back(Int_Type_Ptr);

                ENDIF

//          If Node is selected as a Catalyst, then check for a matching Catalyst on the Interaction_Type


            ELSEIF (Selection_State == EOpt_Node_Selected_As_Catalyst)

            THEN  // ****  REDUNDANT CODE - TO BE REMOVED
                Assert(true == false, "TForm__View_Chemistry::Get_Conns_Matching_Node_And_Type - Invalid Node Selection State");
//                if (Krnl_Vis::IntType::Get_Catalyst_MolType_Ptr(Int_Type_Ptr) == Mol_Type__Ptr)
//                THEN
//                    List_Of_Connections.push_back(Int_Type_Ptr);
//                ENDIF
            ENDIF



        END

//  If the Node is selected as a Product, Then look in its
//  list of connections for which the Node (Molecule_Type) is a Product

    ELSEIF (Selection_State == EOpt_Node_Selected_As_Product)
    THEN
//        for (bool Continue_Flag = Mol_Type__Ptr->List_Of_Int_Types_With_MolType_As_Product.Iter_To_First();
        for (bool Continue_Flag = Krnl_Vis::MolType::Iter_To_First_IntType_With_MolType_As_Product(Mol_Type__Ptr);
             Continue_Flag == true;
             Continue_Flag = Krnl_Vis::MolType::Iter_To_Next_IntType_With_MolType_As_Input(Mol_Type__Ptr))
        BEGIN
//            Interaction_Type* Int_Type_Ptr = Mol_Type__Ptr->
//                                            List_Of_Int_Types_With_MolType_As_Product.Get_Current_Item();
            Interaction_Type* Int_Type_Ptr =
                Krnl_Vis::MolType::Get_Current_IntType_With_MolType_As_Product(Mol_Type__Ptr);

            if ((Krnl_Vis::IntType::Get_Product1_MolType_Ptr(Int_Type_Ptr) == Mol_Type__Ptr)
                        ||
                (Krnl_Vis::IntType::Get_Product2_MolType_Ptr(Int_Type_Ptr) == Mol_Type__Ptr))
            THEN
                List_Of_Connections.push_back(Int_Type_Ptr);
            ENDIF
        END
    ENDIF
}
//----------------------------------------------------------------------------------------------------------

int TForm__View_Chemistry::Get_Number_Of_Possible_Nodes()

//  Get the number of Molecule Types in the Chemistry

{
    return Krnl_Vis::Chemistry_::Get_Number_Of_Molecule_Types();
}
//----------------------------------------------------------------------------------------------------------
/*
Molecule_Type*  TForm__View_Chemistry::Get_Selected_Mol_Type()  const

//  Return pointer to the selected Molecule Type(or zero if none selected)


{
    if (TListView__Nodes_Ptr->Get_Selected()->Get_Data() != 0)
    THEN
        return(static_cast<Molecule_Type*> (TListView__Nodes_Ptr->Get_Selected()->Get_Data()));
    ELSE
        return(0);
    ENDIF
}  */
//-----------------------------------------------------------------------------------------------------------------

bool   TForm__View_Chemistry::Is_On_Active_Page()

//  Return true if the Chemistry and Reactor Tab (which has the Chemistry View) 
//  is on the currently active page

{   
    string Name = GUI_Presentation_API::Get_Active_Page_Label();
    if (Name == string("Chemistry and Reactor Views"))
    THEN
        return true;
    ELSE
        return false;
    ENDIF
}
//----------------------------------------------------------------------------------------------------------
void    TForm__View_Chemistry::List_Connections_For_Node(Molecule_Type*  Molecule_Type__Ptr) const

//  List the Interaction_Types associated with the specified Node (Molecule_Type)
//  Show all Interaction_Types that have the Molecule_Type as an Input or Product
//  Link each ListItem to the Interaction_Type that it lists

{
    GUI_Presentation_API::Clear(Widget_Ids::IntTypes_ListStore);

//    bool Continue_Products = Molecule_Type__Ptr->List_Of_Int_Types_With_MolType_As_Product.Iter_To_First();
    bool Continue_Products = 
        Krnl_Vis::MolType::Iter_To_First_IntType_With_MolType_As_Product(Molecule_Type__Ptr);
//    bool Continue_Inputs = Molecule_Type__Ptr->List_Of_Int_Types_With_MolType_As_Input.Iter_To_First();
    bool Continue_Inputs = 
        Krnl_Vis::MolType::Iter_To_First_IntType_With_MolType_As_Input(Molecule_Type__Ptr);

    while ((Continue_Products || Continue_Inputs) == true)
    BEGIN

        Interaction_Type*   Int_Type_Ptr;

        if(Continue_Products == true)
        THEN
//            Int_Type_Ptr =  Molecule_Type__Ptr->List_Of_Int_Types_With_MolType_As_Product.Get_Current_Item();
            Int_Type_Ptr =  
                Krnl_Vis::MolType::Get_Current_IntType_With_MolType_As_Product(Molecule_Type__Ptr);
//            Continue_Products = Molecule_Type__Ptr->List_Of_Int_Types_With_MolType_As_Product.Iter_To_Next();
            Continue_Products = 
                Krnl_Vis::MolType::Iter_To_Next_IntType_With_MolType_As_Product(Molecule_Type__Ptr);

        ELSEIF (Continue_Inputs == true)
        THEN
//            Int_Type_Ptr = Molecule_Type__Ptr->List_Of_Int_Types_With_MolType_As_Input.Get_Current_Item();
            Int_Type_Ptr =  
                Krnl_Vis::MolType::Get_Current_IntType_With_MolType_As_Input(Molecule_Type__Ptr);

//            Continue_Inputs = Molecule_Type__Ptr->List_Of_Int_Types_With_MolType_As_Input.Iter_To_Next();
            Continue_Inputs = 
                Krnl_Vis::MolType::Iter_To_Next_IntType_With_MolType_As_Input(Molecule_Type__Ptr);
        ELSE
            Assert (false,"TForm__View_Chemistry::List_Connections_For_Node - Should never get here");
        ENDIF

//      Setup the List Item  

        list<string>  List_Of_Strings;
        List_Of_Strings.push_back(To_String(Krnl_Vis::IntType::Get_Identifier(Int_Type_Ptr)));
        List_Of_Strings.push_back(
            Krnl_Vis::IntType::Convert_Int_Type_Categ_To_Text(Krnl_Vis::IntType::Get_Category(Int_Type_Ptr)).c_str());
        List_Of_Strings.push_back(To_String(Krnl_Vis::IntType::Get_Heat_Release(Int_Type_Ptr)));
        List_Of_Strings.push_back(To_String(Krnl_Vis::IntType::Get_Forward_Activation_Energy(Int_Type_Ptr)));      
        List_Of_Strings.push_back(To_String(Krnl_Vis::IntType::Get_Reverse_Activation_Energy(Int_Type_Ptr))); 
        List_Of_Strings.push_back(To_String(Krnl_Vis::IntType::Get_Activated_Complex_Energy(Int_Type_Ptr))); 

        string Fwd_Rate_Const_String(To_String(Krnl_Vis::IntType::Get_Forward_Rate_Constant(Int_Type_Ptr)));
        List_Of_Strings.push_back(Fwd_Rate_Const_String); 

        string Rev_Rate_Const_String(To_String(Krnl_Vis::IntType::Get_Reverse_Rate_Constant(Int_Type_Ptr)));
        List_Of_Strings.push_back(Rev_Rate_Const_String); 

//      Now include the identifiers of the participating Molecule_Types
//      Don't attempt to include participants that are not relevant for the Interaction_Type category

        string R1_String(To_String(Krnl_Vis::IntType::Get_Reactant1_MolType_Id(Int_Type_Ptr)));
        List_Of_Strings.push_back(R1_String);

        string R2_String(Krnl_Vis::IntType::Get_Reactant2_MolType_Text(Int_Type_Ptr));
        List_Of_Strings.push_back(R2_String);

        string P1_String(To_String(Krnl_Vis::IntType::Get_Product1_MolType_Id(Int_Type_Ptr)));
        List_Of_Strings.push_back(P1_String);

        string P2_String(Krnl_Vis::IntType::Get_Product2_MolType_Text(Int_Type_Ptr));
        List_Of_Strings.push_back(P2_String);

        GUI_Presentation_API::Add_Row(Widget_Ids::IntTypes_ListStore, 
                                      List_Of_Strings,
                                      static_cast <void*> (Int_Type_Ptr));
    END
}
//----------------------------------------------------------------------------------------------------------
void    TForm__View_Chemistry::List_Nodes() const

//  List the Chemistry's Molecule_Types and show details of each Molecule_Type
//  In addition, link each screen display item to the Molecule_Type

{
    Molecule_Type*  Molecule_Type__Ptr;

    GUI::Clear(Widget_Ids::MolTypes_ListStore);
    GUI::Clear(Widget_Ids::IntTypes_ListStore);  // Because it will not be correct 
                                                                  // after the redisplay
    
    for (int Continue_Flag = Krnl_Vis::Chemistry_::Iter_To_First_Mol_Type();
         Continue_Flag == true;
         Continue_Flag = Krnl_Vis::Chemistry_::Iter_To_Next_Mol_Type())
    BEGIN
        Molecule_Type__Ptr = Krnl_Vis::Chemistry_::Get_Current_Mol_Type_Ptr();

        list<string>  List_Of_Strings;
        List_Of_Strings.push_back(To_String(Krnl_Vis::MolType::Get_Identifier(Molecule_Type__Ptr)));
        List_Of_Strings.push_back(To_String(Krnl_Vis::MolType::Get_Mass(Molecule_Type__Ptr)));
        List_Of_Strings.push_back(To_String(Krnl_Vis::MolType::Get_Potential_Energy(Molecule_Type__Ptr)));
//  Handler for notification of selection of an item in the MolType ListView
        GUI_Presentation_API::Add_Row(Widget_Ids::MolTypes_ListStore, 
                                      List_Of_Strings,
                                      static_cast <void*> (Molecule_Type__Ptr)); 
    END
}
//----------------------------------------------------------------------------------------------------------------

void  TForm__View_Chemistry::Make()

//  Create the TForm__View_Chemistry singleton object and initialise display

{
    Assert(Form_Ptr == 0,"TForm__View_Chemistry::Make -  Invalid call; TForm__View_Chemistry has already been created");
    CREATE_OBJECT(TForm__View_Chemistry, Form_Ptr = new TForm__View_Chemistry);   
}
//----------------------------------------------------------------------------------------------------------------

void  TForm__View_Chemistry::Notify_MolType_ListView_Selection(void*  Data_Ptr)

//  Handler for notification of selection of an item in the MolType ListView

{
    if (Krnl_Vis::Simulation_Scheduler_::SimProc_IsEnabled()) return;
    
    Molecule_Type*  MolType_Ptr;
    MolType_Ptr = static_cast <Molecule_Type*> (Data_Ptr);
    List_Connections_For_Node(MolType_Ptr);
}
//----------------------------------------------------------------------------------------------------------

void    TForm__View_Chemistry::Remove_Node() const
{
//     **** CODE TO BE COMPLETED
}
//----------------------------------------------------------------------------------------------------------
void    TForm__View_Chemistry::Show_Chemistry(int Num_Nodes)

//  Show a Chemistry View

{
    if (!Form_Ptr)

    THEN
        CREATE_OBJECT(TForm__View_Chemistry, Form_Ptr = new TForm__View_Chemistry());
    ENDIF
    
    Form_Ptr->Set_Number_Of_Nodes(Num_Nodes);
//    Form_Ptr->SetFocus();

//  Show the Molecule Types and Interaction Types
    
//    Form_Ptr->List_Nodes();
}    
//----------------------------------------------------------------------------------------------------------

TForm__View_Chemistry::TForm__View_Chemistry()

{
//    Chemistry__Ptr = Chemistry::Get_Chemistry__Ptr();
    Form_Ptr = this;   // Form_Ptr is static

//  Initialise the form

    Initialise_Form(Get_Number_Of_Possible_Nodes(),
                    true,  //  Do display all interaction types initially
                    Widget_Ids::Chemistry_Draw_Area);
}
