/****************************************************************************
*
*	  Header Filename:  Simulation_Display_API.h
*	  Module Name:      Simulation_Display_API
*	  Description:      Interface to User Interface Subsystem for display updates
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2006, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License Version 2, as published 
*     by the Free Software Foundation.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*     Amendment History:-
*
*         Version    Date                 Update Description
*         =======    ===========          ==================
*
*
*
*
****************************************************************************/

#ifndef Simulation_Display_API_H
#define Simulation_Display_API_H

namespace API {}  // Exists only to make KDevelop display Simulation_Display_API in explorer

class   Simulation_Display_API

{
//===== Relationships with other classes ===================================================================

//==========================================================================================================

    public:

        static void Output_Log_Entry(string Action_Report);
        static void Output_Simple_Log_Entry(string Action_Report);
        static void Display_Chemistry();
        static void Display_Reactor();
        static void Display_Object_Statistics();
        static void Display_Statistics_Optimised(bool Simulation_Running);
        static void Save_Statistics_Display(string* Filename_Ptr);

    private:

};
#endif  //Simulation_Display_API_H
