/****************************************************************************
*
*	  Module Filename:  Network_Painter_Prot.cpp
*	  Module Name:      Network_Painter_Prot
*	  Description:      Network_Painter Protocol Class
*	  Author:   		Chris Gordon-Smith
*
*     Copyright (C) 2003, 2004, 2005, 2006, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License Version 2, as published 
*     by the Free Software Foundation.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*	  Amendment History:-
*
*		Version	   Date	   			Update Description
*		=======    ===========		==================
*
*
*
*
****************************************************************************/

//	Globally used definitions / declarations

#include "globldef.h"
#include "Library_Headers.h"

//--------------  GUI Presentation Subsystem API ----------------------------------------------------------------
#include  "GUI_Presentation_API.h"
//---------------------------------------------------------------------------------------------------------------

//-------------- Network Painte Subsystem  ----------------------------------------------------------------------
#include "Network_Painter_Prot.h"
#include "Network_Painter.h"
//---------------------------------------------------------------------------------------------------------------

//----------------------------------------------------------------------------------------------------------

Network_Painter_Prot*  Network_Painter_Prot::Make_Network_Painter(int     NumOfNodesPerDisplayRow,
                                                                  int     SpaceInPixelsBetweenNodes,
                                                                  double   Typical_Connection_Strength,
                                                                  double   Typical_Node_Strength,
                                                          //        void*   TPaintBox__NetworkDisplayPtr,
                                                                  bool    Display_All_Connections_Ind,
                                                                  Widget_Ids::Drawing_Area_Id Draw_Area_Id)
//  Factory routine to create a Network_Painter 

{
 
    CREATE_OBJECT(Network_Painter, return new  Network_Painter(NumOfNodesPerDisplayRow,
                                SpaceInPixelsBetweenNodes,
                                Typical_Connection_Strength,
                                Typical_Node_Strength,
                    //            TPaintBox__NetworkDisplayPtr,
                                Display_All_Connections_Ind, 
                                Draw_Area_Id));
}
//----------------------------------------------------------------------------------------------------------
Enum_Node_Selection_State   Network_Painter_Prot::Manage_Node_Selection_State::First()

//  Return the first Node selection state

{
    return EOpt_Node_Selected_As_Reactant;
}
//----------------------------------------------------------------------------------------------------------
Enum_Node_Selection_State   Network_Painter_Prot::Manage_Node_Selection_State::Next(Enum_Node_Selection_State Selection_State)

//   Given a particular Node Selection State, return the next selection state, or (if
//   already at the last selection state), return to the first.

{
    Assert(Selection_State < EOpt_Node_Selection_End
                       &&
           Selection_State >=  EOpt_Node_Selected_As_Reactant,
           "Network_Painter_Prot::Node_Selection_State::Next - Invalid argument");

    if (Selection_State == (EOpt_Node_Selection_End - 1))
    THEN
        return EOpt_Node_Selected_As_Reactant;
    ELSE
        return static_cast <Enum_Node_Selection_State> (Selection_State + 1);
    ENDIF
}
