/****************************************************************************
*
*     Header Filename:  GUI_Item_Ids.h
*     Module Name:      GUI Item Identifiers
*     Description:      Identifiers for items used by the SimSoup
*                       User Interface Presentation Layer and referenced by the
*                       User Interface Manager
*
*     Author:           Chris Gordon-Smith
*
*     Copyright (C) 2007, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License as published by the
*     Free Software Foundation; either version 2 of the License, or (at your
*     option) any later version.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*      Amendment History:- 
*
*              Version    Date                        Update Description
*              =======    ===========                 ==================
*
*
*
*
****************************************************************************/

#ifndef GUI_Item_Ids_H
#define GUI_Item_Ids_H

class   Widget_Ids
{
    public:

        enum Drawing_Area_Id {SimStats_Draw_Area = 0, 
                              Chemistry_Draw_Area = 1,
                              Reactor_Draw_Area = 2,
                              Num_Draw_Areas = 3};

        enum ListStore_Id {SimStats_Groups_ListStore = 0, 
                           SimStats_SerList_ListStore = 1,
                           SimStats_Series_ListStore = 2, 
                           MolTypes_ListStore = 3,
                           IntTypes_ListStore = 4,
                           R_MolType_ListStore = 5,
                           R_IntType_ListStore = 6,
                           Simulation_Actions_ListStore = 7,
                           SysMon_ListStore = 8,
                           Num_ListStores = 9};

        enum ListView_Id {SimStats_Groups_ListView = 0, 
                          SimStats_SerList_ListView = 1,
                          SimStats_Series_ListView = 2, 
                          MolTypes_ListView = 3,
                          R_MolTypes_ListView = 4,
                          Num_ListViews = 5};

        enum TextBuffer_Id {SimControl_Log_TextBuffer = 0,
                            Help_About_TextBuffer = 1,
                            Help_Quick_Start_TextBuffer = 2,
                            Help_Licence_TextBuffer = 3,
                            Num_TextBuffers = 4};
};

class   Colour_Ids
{
    public:
        enum SimSoupColour {Blue = 0, Red = 1, Green = 2, Black = 3, White = 4, LimeGreen = 5, Maroon = 6};
};
    typedef  Colour_Ids::SimSoupColour  Colour_Id;


#endif  //GUI_Item_Ids_H
